<?php

class USERLISTE{
	private $db;
	private $uid;
	private $array = array();
	private $seite;
	
	public function __construct(){
		global $datenbank;
		$this->db = $datenbank;
	}
	
	public function liste(){
		$aus = '
		<table class="table table-bordered table-striped">
			<tr>
				<th>#</th>
				<th>UID</th>
				<th>
					Kontostand<br>
					<small><i>(W&auml;hrung/Bonusw&auml;hrung)</i></small>
				</th>
				<th>Nickname</th>
				<th>Name</th>
				<th>Emailadresse</th>
				<th>Angemeldet</th>
				<th></th>
			</tr>';
		$daten = $this->db->get_results("
									SELECT 
										u.*,k.kontostand_a,k.kontostand_b,k.status,e.emailadresse 
									FROM 
										". PREFIX . KONTO ." AS k
									LEFT JOIN
										". PREFIX . USER ." AS u 
									ON 
										u.uid=k.uid
									LEFT JOIN 
										" . PREFIX . EMAIL . " AS e 
									ON 
										e.uid=k.uid
									ORDER BY 
										k.uid ASC ");
		foreach($daten AS $dat){
			if($dat->status == 0){
				$icon = 'glyphicon-ban-circle';
				$alt = 'Best&auml;tigung fehlt';
				$color = 'yellow';
			}elseif($dat->status == 1){
				$icon = 'glyphicon-ok-circle';
				$alt = 'freigeschaltet';
				$color = 'green';
			}elseif($dat->status == 2){
				$icon = 'glyphicon-remove-circle';
				$alt = 'Gesperrt';
				$color = 'red';
			}
			$aus .= "
				<tr>
					<td><span class='glyphicon $icon' alt='$alt' aria-hidden='true' style='color:$color;'></span></td>
					<td>$dat->uid</td>
					<td>".number_format($dat->kontostand_a,2,',','.') ."/". number_format($dat->kontostand_b,2,',','.') ."</td>
					<td>$dat->nickname</td>
					<td>$dat->vorname</td>
					<td>$dat->nachname</td>
					<td>". date("d.m.Y H:i",$dat->angemeldet_seit) ."</td>
					<td><a href='?content=/usersystem/details&uid=". $dat->uid ."' class='btn btn-default'>Details</a></td>
				</tr>";
		}
		$aus .= '</table>';
		return $aus;
	}
	
	public function profil_save($post){
		global $meldung;
		$this->make_array($post);
		$user = array("nickname" => $this->array['nickname']);
		$mail = array("emailadresse" => $this->array['emailadresse'], "freigabe_fuer" => $this->array['freigabe_fuer']);
		$konto = array(
			"bettel_sperre" => $this->array['bettel_sperre'],
			"forced_sperre" => $this->array['forced_sperre'],
			"chat_sperre" => $this->array['chat_sperre'],
			"auszahlung_sperre" => $this->array['auszahlung_sperre']
		);
		$update = $this->db->update(PREFIX . KONTO , $konto, array("uid" => $this->uid));
		$update = $this->db->update(PREFIX . EMAIL , $mail, array("uid" => $this->uid));
		$update = $this->db->update(PREFIX . USER , $user, array("uid" => $this->uid));
		$meldung = ALLGEMEINE_DATEN_SAVE;
	}
	
	private function make_array($post){
		foreach($post AS $key => $value){
			if($key != 'profile_save' && $key != 'notice'){
				$this->array[$key] = $value;
			}
		}
	}
	
	public function set_uid($uid){
		if(!is_numeric($uid)){ $this->uid = 0;}else{$this->uid = $uid;}
	}
	
	public function startseite(){
		$erg = $this->db->get_row("SELECT COUNT(uid) AS kd_uid , SUM(kontostand_a) AS kd_kontostand FROM ". PREFIX . KONTO ."",true);
		return $erg;
	}
	
	public function Chart(){
		$array = array("label" => "", "ges" => "");
		$result = $this->db->get_results("SELECT datum,SUM(ein) AS ein, SUM(aus) as aus FROM ". PREFIX . BILANZ ." GROUP BY datum ORDER BY datum ASC LIMIT 14");
		foreach($result AS $res){
			$array['label'] .= 	'"'.date("d.m.",$res->datum).'"' .",";
			$array['ges'] .= $res->ein - $res->aus .',';
		}
		
		return $array;
	}
	
	public function userinfo(){
		$daten = $this->db->get_row("
					SELECT 
						u.*,k.*,b.*,e.* 
					FROM 
						". PREFIX . KONTO ." AS k
					LEFT JOIN
						". PREFIX . USER ." AS u 
					ON 
						u.uid=k.uid
					LEFT JOIN 
						" . PREFIX . EMAIL . " AS e 
					ON 
						e.uid=k.uid
					LEFT JOIN
						". PREFIX . BUCH ." AS b
					ON
						b.uid = k.uid
					WHERE k.uid = '$this->uid'
					",true);
		return $daten;
	}
	
	public function set_bseite($seite){
		$this->seite = $seite * 30 - 30;	
	}
	
	public function buchungen($seite = 0){
		$aus = array("A" => "", "B" => "");
		$bua = $this->db->get_results("SELECT * FROM ". PREFIX . BUCH." WHERE uid='$this->uid' ORDER BY buchungszeit  DESC LIMIT $this->seite,30");
		foreach($bua AS $b){
			if($b->buchungsmenge < 0){ $style = 'class="alert alert-danger"';}else{ $style = 'class="alert alert-success"';}
			if($b->buchung_ok == 1){
				$erfolg = '<span class="glyphicon glyphicon-ok" style="color:green;" aria-hidden="true"></span>';
			}else{
				$erfolg = '<span class="glyphicon glyphicon-remove" style="color:red" aria-hidden="true"></span>';
			}
			$aus['A'] .= '
				<tr '.$style.'>
					<td>'. date("d.m.Y H:i",$b->buchungszeit) .'</td>
					<td>'. $b->buchungs_id .'</td>
					<td>'. number_format($b->buchungsmenge,2,',','.') .'</td>
					<td>'. $b->verwendungszweck .'</td>
					<td>'. $b->buchungs_id .'</td>
					<td class="text-center">'. $erfolg .'</td>
				</tr>
			';
		}
		
		$bub = $this->db->get_results("SELECT * FROM ". PREFIX . BUCH_B ." WHERE uid='$this->uid' ORDER BY buchungszeit  DESC LIMIT $this->seite,30");
		foreach($bub AS $b){
			if($b->buchungsmenge < 0){ $style = 'class="alert alert-danger"';}else{ $style = 'class="alert alert-success"';}
			if($b->buchung_ok == 1){
				$erfolg = '<span class="glyphicon glyphicon-ok" style="color:green;" aria-hidden="true"></span>';
			}else{
				$erfolg = '<span class="glyphicon glyphicon-remove" style="color:red" aria-hidden="true"></span>';
			}
			$aus['B'] .= '
				<tr '.$style.'>
					<td>'. date("d.m.Y H:i",$b->buchungszeit) .'</td>
					<td>'. $b->buchungs_id .'</td>
					<td>'. number_format($b->buchungsmenge,2,',','.') .'</td>
					<td>'. $b->verwendungszweck .'</td>
					<td>'. $b->buchungs_id .'</td>
					<td class="text-center">'. $erfolg .'</td>
				</tr>
			';
		}
		
		return $aus;
	}
	
	public function bettel_ref(){
		$aus = '';
		$result = $this->db->get_results("SELECT * FROM ". PREFIX . BETTELB ." WHERE uid = '$this->uid' ORDER BY id DESC LIMIT 120");
		foreach($result AS $res){
			$aus .= '
				<tr>
					<td>'.date("d.m.Y - H:i", $res->zeit).'</td>
					<td>'.number_format($res->betrag,2,",",".").'</td>
					<td><a href="'.$res->refferer.'" target="_new">'.$res->refferer.'</a></td>
				</tr>
			';
		}
		return $aus;
	}
	
	public function ShowNotizen(){
		$result = $this->db->get_results("SELECT * FROM ". PREFIX . NOTIZ ." WHERE uid = '$this->uid' ");
		foreach($result AS $res){
			echo '
			 <li class="list-group-item">
				<div class="row">
					<div class="col-md-3">'. date("d.m.Y", $res->datum) .'</div>
					<div class="col-md-9">'. nl2br($res->text) .'</div>
				</div>
			</li>
			';
		}
	}
	
	public function AddNotiz(){
		global $_POST,$_GET,$error,$meldung;
		$this->make_array($_POST);
		if(empty($this->array['text'] )){ $error = 1; $meldung .= NOTIZ_EMPTY;}
		if($error == 0){
			$eintrag = array(
				"uid" => $this->uid,
				"text" => $this->array['text'],
				"datum" => time()
			);
			$insert = $this->db->insert(PREFIX . NOTIZ, $eintrag);
			if($insert == true){
				$meleung = NOTIZ_SAVE_TRUE;
			}else{
				$error = 1;
				$meldung = NOTIZ_SAVE_FALSE;
			}
		}
	}
}
